import express from 'express';
import { Logger } from 'winston';
import { CatalogApi as CatalogApi$1, CatalogClient } from '@backstage/catalog-client';
import * as graphql_modules from 'graphql-modules';
import { Module } from 'graphql-modules';
import * as _envelop_core from '@envelop/core';

declare type CatalogApi = Pick<CatalogApi$1, "getEntityByRef">;

interface createGraphQLAppOptions {
    catalog: CatalogApi;
    modules: Module[];
}
declare function createGraphQLApp(options: createGraphQLAppOptions): {
    run: _envelop_core.GetEnvelopedFn<{
        [x: string]: any;
        [x: number]: any;
        [x: symbol]: any;
    }>;
    application: graphql_modules.Application;
};

interface RouterOptions {
    logger: Logger;
    catalog: CatalogClient;
    modules?: Module[];
}

declare function createRouter(options: RouterOptions): Promise<express.Router>;

export { RouterOptions, createGraphQLApp, createGraphQLAppOptions, createRouter };
